package weapp

import (
	"net/http"

	"github.com/gin-gonic/gin"
	"github.com/shockliu/logger"
)

// 小程序客服通知消息鉴权
func CheckSign(c *gin.Context) {
	/* 开发者提交信息后，微信服务器将发送GET请求到填写的服务器地址URL上，GET请求携带参数如下表所示：
	参数	描述
	signature	微信加密签名，signature结合了开发者填写的token参数和请求中的timestamp参数、nonce参数。
	timestamp	时间戳
	nonce	随机数
	echostr	随机字符串
	*/
	//signature:=c.Query("signature")
	//nonce:=c.Query("nonce")
	echostr := c.Query("echostr")
	logger.Debugf("微信小程序消息推送鉴权%s\n", echostr)
	c.String(http.StatusOK, echostr)
}
